#include "reg8252.h"
#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#include "variables35.h"
#include "siemens35.h"

#define WORD unsigned int

// funkcja realizuje opnienie k*1ms dla rezonatora f=11,0592 MHz
void delay(WORD k)
{
	WORD i,j;
	for ( j = 0; j < k; ++j)
		for (i = 0; i <= 451; ++i);
}

//wysanie numeru PIN do telefonu, ustawienie sposobu powiadamiania
bit initgsm()
{
	idata char temp[8];

	printf("%s\n",CPIN);			//wprowadzenie numeru PIN
	gets(&temp);					//jeli PIN by poprawny, to komunikat "OK"+0D+0A
									//jeli komunikat !OK, wwczas funkcja zwraca 0 i koniec
	if (strncmp(temp, "OK", 2) != 0) return(0);

	printf("%s\n",ECHOOFF);		//wyczenie echa rozkazu
	gets(&temp);
	printf("%s\n",SETNOTICE);	//ustawienie trybu powiadomienia o SMS-ie
	gets(&temp);
	printf("%s\n",SETCLIP);		//za. trybu powiadomienia o numerze aparatu dzwonicego
	gets(&temp);
	return(1);
}

//wysanie wiadomoci SMS
void sendsms(generic char *tekst)
{
	char len, i, n, ch_1, ch_2;

	n = len = strlen(tekst);	//obliczenie dugoci acucha znakw po zakodowaniu
	i = n / 8;						//liczc od "pierwszego oktetu"
	n = i * 7 + i % 8 + 13;
	printf("%s%d\n", SMSSEND, n);
	while(_getkey() != '>');	//oczekiwanie na znak "zachty"
	printf("%02X%02X%s%02X%02X%02X%02X%s%02X%02X%02X%02X", LOSCA, TOSCA, 
			 SCA, FO, MR, LODA, TODA, DA, PID, DCS, SCTS, len);
	i = 0;
	while (i < len)
	{
		ch_1 = *(tekst + i);		//pobranie pierwszego znaku tekstu
		ch_2 = *(tekst + i + 1);//pobranie nastpujcego za nim znaku
		n = i % 8;					//obliczenie liczby przesuni
		ch_1 >>= n;				//przesunicie pierwszego znaku w prawo
		n = 7-n;					//wyliczenie dopenienia liczby przesuni 
									//dla drugiego znaku
		ch_2 <<= n;				//przesunicie drugiego znaku w lewo
		ch_1 += ch_2;				//wyliczenie kodu nowo powstaego znaku
		printf("%02X", ch_1);	//wysanie znaku szesnastkowego
		i++;						//nastpna pozycja w acuchu
		if (n == 1) i++;			//dla kadego smego znaku przesunicie o 1 bit,
									//znak jest "gubiony"
	}                             
	putchar(0x1A);				//wysanie znaku koca EOT+CR
	putchar(0x0D);
}


//pobiera liczb szesnastkow w postaci tekstu spod wskazanego adresu i wykonuje 
//konwersj na typ unsigned int (WORD)
WORD str2num(generic char *addr)
{
	data char temp[2];
	WORD num;

	temp[0] = *addr;
	temp[1] = *(addr+1);
	sscanf(temp, "%X", &num);
	return (num);
}


//odbir wiadomoci SMS
void receivesms(generic char *tekst)
{
	WORD i;
	char ch_1, ch_2, n, pos;
	data char temp[20];
	generic char *ptr;

	ptr = tekst;					//bufor posuy do zapamietywania tekstu
	gets(tekst);					//oczekiwanie na powiadomienie zgodne z wzorcem w NOTICE
	if (strncmp(tekst, &NOTICE, 6) == 0)
	{
	  sscanf((tekst+12), "%i", &i);
									//wyodrbnienie indeksu w pamici
	  printf("%s%c%c\n", CHOOSEMEM, *(tekst+8), *(tekst+9)); 
									//wybr pamici do odczytu SMS-a
	  gets(temp);					//pobranie informacji o statusie CPMS
	  gets(temp);					//pobranie OK
	  printf("%s%i\n", SMSREAD, i);			
	  gets(tekst);				//pobranie SMS-a
	  gets(temp);					//pobranie OK
	  printf("%s%i\n", SMSDEL, i);
									//usunicie SMS-a z pamici telefonu
	  gets(temp);					//pobranie OK
	
	  i = str2num(tekst);		//przesunicie wskanika poza numer SCA (Centrum Usug)
	  tekst += 2 * i + 4;		//i pierwszy oktet
	
	  i = str2num(tekst);		//przesunicie wskanika poza pola: typ numeru nadawcy,
	  tekst += 22 + i + i % 2;	//numer nadawcy, id. protokou, schemat kodowania, znacznik
									//czasu
	  i = str2num(tekst);		//wyznaczenie dugoci acucha
	  tekst += 2;					//wskazanie do pierwszej pozycji tekstu SMS-a
	
	  while (pos < i) 			//dopki nie przekroczono rozmiaru acucha
	  {
		ch_1 = str2num(tekst);	//zamiana acucha na kod znaku
		n = pos % 8;				//obliczenie liczby przesuni dla pierwszego znaku
		ch_1 <<= n;				//przesunicie pierwszego znaku w lewo n razy
		ch_1 += ch_2;				//maskowanie najstarszego bitu oraz uwzgldnienie bitw
		ch_1 &= 0x7F;				//przeniesienia (przy kodowaniu)
		*ptr = ch_1;				//zapis wyliczonego kodu znaku do bufora
		ptr++;						//nastpna pozycja w buforze
		n = 7 - n;					//wyliczenie iloci przesuni nastpnego znaku dla
		ch_2 = str2num(tekst) >> n;
									//odzyskania bitw utraconych przy kodowaniu
		if (n == 0) 				//cyklicznie - 8. znak brany jest w caoci
		{
		  ch_2 = 0;
		  tekst -= 2;
		}
		pos++;						//nastpna pozycja w dekodowanym cigu
		tekst += 2;
	  }
	  *ptr = 0;					//zapis znaku koca acucha
	}
}


//funkcja wysya komend AT do telefonu GSM i sprawdza, czy dotar komunikat OK
//jeli tak, zwracana jest warto TRUE; dodatkowo jest uruchamiany watchdog
bit gsmconnected()
{
	idata char temp[4];

	SCK = 0;						//zawiecenie diody LED na czas testu doczenia 
									//aparatu gsm
	WMCON |= 0xE0;				//start ukadu watchdog; nastawa 2048 ms
	WMCON |= 0x01;

	printf("%s\n","AT");
	gets(&temp);
	gets(&temp);					//pobranie "OK"+0A+0D
	SCK = 1;						//wyczenie diody led
	if (strncmp(temp, "OK", 2) == 0) return(1); else return(0);

	WMCON |= 0x02;				//zerowanie timera watchdog
	WMCON &= 0xFE;				//zatrzymanie watchdoga
}

//rozczenie poczenia
void disconnect()
{
	printf("%s\n",DISCONNECT);	//poczenie sprawdzone, rozczenie
}
